<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>LibGE: src/AGSymbol.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="cropped-BDS-Logo-1.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">LibGE
   &#160;<span id="projectnumber">0.31.0</span>
   </div>
   <div id="projectbrief">A c++ GE implementation</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">AGSymbol.h</div>  </div>
</div><!--header-->
<div class="contents">
<a href="_a_g_symbol_8h.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// AGSymbol.h -*- C++ -*-</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160; </div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#ifndef _AGSYMBOL_H_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#define _AGSYMBOL_H_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment">/* This class implements a symbol of an Attribute Grammar, be it a non-terminal  */</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment">/* or terminal symbol. Type cast as its super class Symbol, it is used both by   */</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment">/* the Rule class, to specify its left side non-terminal symbols, and by the     */</span> </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment">/* Production class, to specify its  terminal and non-terminal symbols.          */</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment">/* It is also used by the Phenotype class, to specify phenotypic symbols.        */</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment">/* It can hold any data type, but all data types will be treated as text, so     */</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment">/* for example no arithmetic operations are possible.                            */</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment">/* - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - */</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160; </div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment">//Forward Declaration due to circular dependency between AGSymbol and AGContext.</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment">//AGSymbol requires AGContext; AGContext requires AGTree, which in turn needs</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment">//AGSymbol.</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="keyword">class </span><a class="code" href="class_a_g_look_up.html">AGLookUp</a>;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="keyword">class </span><a class="code" href="class_a_g_context.html">AGContext</a>;</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160; </div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="lib_g_edefs_8h.html">libGEdefs.h</a>&quot;</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="_symbol_8h.html">Symbol.h</a>&quot;</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="comment">//#include &quot;AGLookUp.h&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160; </div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="preprocessor">#include&lt;iostream&gt;</span></div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="preprocessor">#include&lt;vector&gt;</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;<span class="preprocessor">#include&lt;string&gt;</span></div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;<span class="preprocessor">#include&lt;sstream&gt;</span></div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160; </div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="comment">//Return Types of Semantic Functions</span></div><div class="line"><a name="l00032"></a><span class="lineno"><a class="line" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28aa0afa825567e442a46d131be6c71cb40f">   32</a></span>&#160;<span class="keyword">enum</span> <a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a> {<a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28aa0afa825567e442a46d131be6c71cb40f">PASS</a>,<a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28aa936c4a5547a9360243178f726f6b2715">FAIL</a>,<a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28aa08ae9c164a688c9072b140d190f57bae">CONSTRAINT_VIOLATION</a>};</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160; </div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160; </div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;<span class="keyword">using namespace </span>std;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160; </div><div class="line"><a name="l00037"></a><span class="lineno"><a class="line" href="class_a_g_symbol.html">   37</a></span>&#160;<span class="keyword">class </span><a class="code" href="class_a_g_symbol.html">AGSymbol</a> : <span class="keyword">public</span> <a class="code" href="class_symbol.html">Symbol</a>{</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <a class="code" href="class_a_g_symbol.html">AGSymbol</a>(<span class="keyword">const</span> <span class="keywordtype">string</span>, <span class="keyword">const</span> <a class="code" href="_symbol_8h.html#add8909e1085c0c32f8380ff493a243b3">SymbolType</a>);</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        <a class="code" href="class_a_g_symbol.html">AGSymbol</a>(<span class="keyword">const</span> <a class="code" href="class_a_g_symbol.html">AGSymbol</a>&amp;);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keyword">virtual</span> ~<a class="code" href="class_a_g_symbol.html">AGSymbol</a>();</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a> updateSynthesisedAttributes(<a class="code" href="class_a_g_context.html">AGContext</a> &amp;, <span class="keyword">const</span> <span class="keywordtype">int</span> prodIndex, <a class="code" href="class_a_g_look_up.html">AGLookUp</a>&amp; lookUp)=0;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keyword">virtual</span> <a class="code" href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a> updateInheritedAttributes(<a class="code" href="class_a_g_context.html">AGContext</a> &amp;, <span class="keyword">const</span> <span class="keywordtype">int</span> prodIndex, <a class="code" href="class_a_g_look_up.html">AGLookUp</a>&amp; lookUp)=0;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;        <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;  <a class="code" href="class_a_g_symbol.html">AGSymbol</a> &amp;operator=(<span class="keyword">const</span> T);</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="keywordtype">bool</span> operator==(<span class="keyword">const</span> <a class="code" href="class_a_g_symbol.html">AGSymbol</a>&amp;);</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;                <span class="keyword">virtual</span> <span class="keywordtype">bool</span> getInUse() <span class="keyword">const</span>;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;                <span class="keyword">virtual</span> <span class="keywordtype">void</span> setInUse(<span class="keywordtype">bool</span>);</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        <span class="keyword">virtual</span> <span class="keyword">const</span> vector&lt;bool&gt;* getValidProductionIndices() <span class="keyword">const</span>;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    <span class="keyword">protected</span>:</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="comment">//This variable is useful for recycling AGSymbol objects. When </span></div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;        <span class="comment">//true, this indicates that this object is in use as a part of </span></div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;        <span class="comment">//an AGDerivationTree object; otherwise, the object is free to be</span></div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;        <span class="comment">//used else where. </span></div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="class_a_g_symbol.html#ae63a68fcd61358feeaa0895f72b80810">   54</a></span>&#160;        <span class="keywordtype">bool</span> <a class="code" href="class_a_g_symbol.html#ae63a68fcd61358feeaa0895f72b80810">inUse</a>; </div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;};</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160; </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;<span class="comment">// Copy newValue as textual contents of Symbol.</span></div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;<span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;</div><div class="line"><a name="l00060"></a><span class="lineno"><a class="line" href="class_a_g_symbol.html#a548e1eaf04e174f9e9eb17789bc0b876">   60</a></span>&#160;      <a class="code" href="class_a_g_symbol.html">AGSymbol</a> &amp;<a class="code" href="class_a_g_symbol.html#a548e1eaf04e174f9e9eb17789bc0b876">AGSymbol::operator=</a>(<span class="keyword">const</span> T newValue){</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="comment">//Pass it on to the superclass. </span></div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <a class="code" href="class_symbol.html#a9a992177f59b310d6319a59237a8aad2">Symbol::operator=</a>(newValue);</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <span class="keywordflow">return</span> *<span class="keyword">this</span>;</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;}</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="a_a_g_symbol_8h_html_a957d51e6618189668fefc29a518bf28aa08ae9c164a688c9072b140d190f57bae"><div class="ttname"><a href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28aa08ae9c164a688c9072b140d190f57bae">CONSTRAINT_VIOLATION</a></div><div class="ttdef"><b>Definition:</b> AGSymbol.h:32</div></div>
<div class="ttc" id="a_a_g_symbol_8h_html_a957d51e6618189668fefc29a518bf28aa0afa825567e442a46d131be6c71cb40f"><div class="ttname"><a href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28aa0afa825567e442a46d131be6c71cb40f">PASS</a></div><div class="ttdef"><b>Definition:</b> AGSymbol.h:32</div></div>
<div class="ttc" id="aclass_symbol_html"><div class="ttname"><a href="class_symbol.html">Symbol</a></div><div class="ttdef"><b>Definition:</b> Symbol.h:28</div></div>
<div class="ttc" id="aclass_a_g_symbol_html"><div class="ttname"><a href="class_a_g_symbol.html">AGSymbol</a></div><div class="ttdef"><b>Definition:</b> AGSymbol.h:37</div></div>
<div class="ttc" id="aclass_a_g_symbol_html_a548e1eaf04e174f9e9eb17789bc0b876"><div class="ttname"><a href="class_a_g_symbol.html#a548e1eaf04e174f9e9eb17789bc0b876">AGSymbol::operator=</a></div><div class="ttdeci">AGSymbol &amp; operator=(const T)</div><div class="ttdef"><b>Definition:</b> AGSymbol.h:60</div></div>
<div class="ttc" id="aclass_a_g_symbol_html_ae63a68fcd61358feeaa0895f72b80810"><div class="ttname"><a href="class_a_g_symbol.html#ae63a68fcd61358feeaa0895f72b80810">AGSymbol::inUse</a></div><div class="ttdeci">bool inUse</div><div class="ttdef"><b>Definition:</b> AGSymbol.h:54</div></div>
<div class="ttc" id="aclass_symbol_html_a9a992177f59b310d6319a59237a8aad2"><div class="ttname"><a href="class_symbol.html#a9a992177f59b310d6319a59237a8aad2">Symbol::operator=</a></div><div class="ttdeci">Symbol &amp; operator=(const T)</div><div class="ttdef"><b>Definition:</b> Symbol.h:44</div></div>
<div class="ttc" id="alib_g_edefs_8h_html"><div class="ttname"><a href="lib_g_edefs_8h.html">libGEdefs.h</a></div></div>
<div class="ttc" id="a_symbol_8h_html_add8909e1085c0c32f8380ff493a243b3"><div class="ttname"><a href="_symbol_8h.html#add8909e1085c0c32f8380ff493a243b3">SymbolType</a></div><div class="ttdeci">SymbolType</div><div class="ttdef"><b>Definition:</b> Symbol.h:24</div></div>
<div class="ttc" id="a_a_g_symbol_8h_html_a957d51e6618189668fefc29a518bf28aa936c4a5547a9360243178f726f6b2715"><div class="ttname"><a href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28aa936c4a5547a9360243178f726f6b2715">FAIL</a></div><div class="ttdef"><b>Definition:</b> AGSymbol.h:32</div></div>
<div class="ttc" id="a_a_g_symbol_8h_html_a957d51e6618189668fefc29a518bf28a"><div class="ttname"><a href="_a_g_symbol_8h.html#a957d51e6618189668fefc29a518bf28a">AGMapState</a></div><div class="ttdeci">AGMapState</div><div class="ttdef"><b>Definition:</b> AGSymbol.h:32</div></div>
<div class="ttc" id="aclass_a_g_look_up_html"><div class="ttname"><a href="class_a_g_look_up.html">AGLookUp</a></div><div class="ttdef"><b>Definition:</b> AGLookUp.h:22</div></div>
<div class="ttc" id="a_symbol_8h_html"><div class="ttname"><a href="_symbol_8h.html">Symbol.h</a></div></div>
<div class="ttc" id="aclass_a_g_context_html"><div class="ttname"><a href="class_a_g_context.html">AGContext</a></div><div class="ttdef"><b>Definition:</b> AGContext.h:28</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
